{% extends "Base.html" %}

{% block title %} Submit {% endblock title %}

{% block content %}

<div class="container px-4 py-5">
    {% comment %} <h2 class="pb2 border-bottom"> Построение математической модели двигателя EV3 </h2> {% endcomment %}
    <nav aria-label="breadcrumb">
        <ol class="fs-3 breadcrumb">
            <li class="breadcrumb-item"><a href="/">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Лаб. {{ lab.number }} {{ lab.name }}</li>
        </ol>
    </nav>

    <div class="row g-4 py-5 row-cols-1 row-cols-lg-2">

        <form enctype="multipart/form-data" action="/labs/{{lab.number}}/submit" method="post">
            {% csrf_token %}

            <div id="participants">

                {% comment %} Here is student fields {% endcomment %}

            </div>

            <div class="d-md-flex justify-content-md-end col-12 my-4">
                <span class="form-text me-3">Добавить нового участника команды</span>
                <button type="button" class="btn btn-primary btn-sm me-md-2" id="add-user">add</button>
                <button type="button" class="btn btn-secondary btn-sm" id="rm-user">remove</button>
            </div>

            <div class="mb-3 has-validation">
                <label for="formFile" class="fw-medium form-label">Файл отчета лабораторной работы в формате PDF</label>
                <input class="form-control" type="file" id="formFile" name="report" required>
                <div class="invalid-feedback">
                    Поле не заполнено
                </div>
            </div>

            <div class="mb-3 has-validation">
                <label for="telegram" class="fw-medium form-label">Telegram для связи с ответственным участником</label>
                <input class="form-control" type="text" placeholder="@telegram" id="telegram" name="telegram" pattern=".*\B@(?=\w{5,32}\b)[a-zA-Z0-9]+(?:_[a-zA-Z0-9]+)*.*" required>
                <div class="invalid-feedback">
                    Поле не заполнено
                </div>
            </div>

            <div class="mb-3">
                <label class="fw-medium form-label"> Что вы делали в работе? С какими сложностями столкнулись? Дайте короткий ответ </label>
                <div class="form-floating">
                    <textarea class="form-control" placeholder="Leave a comment here" id="floatingTextarea2" name="comments" style="height: 100px"></textarea>
                    <label for="floatingTextarea2">Комментарии</label>
                </div>
            </div>

            <input type="hidden" id="stud-number" name="stud-number" value="3">

            <button type="submit" class="btn btn-primary">Submit</button>






            {% comment %} Data ITMO Students {% endcomment %}

            <datalist id="exampleITMOIDList">
                {% for student in students %}
                    <option value="{{ student.id }}" id="id-{{ student.id }}">
                {% endfor %}
                {% comment %} <option value="192059" id="id-192059">
                <option value="192060" id="id-192060">
                <option value="192061" id="id-192061">
                <option value="192062" id="id-192062">
                <option value="192063" id="id-192063"> {% endcomment %}
            </datalist>

            <datalist id="exampleITMONameList">
                {% for student in students %}
                    <option value="{{ student.last_name }} {{ student.first_name }} {{ student.middle_name }}" id="fio-{{ student.id }}">
                {% endfor %}
                {% comment %} <option value="Овчаров А. О."   id="fio-192059">
                <option value="Чергинец Д. А."  id="fio-192060">
                <option value="Никифоров В. С." id="fio-192061">
                <option value="Ковалева Д. Р."  id="fio-192062">
                <option value="Ведяков А. А."   id="fio-192063"> {% endcomment %}
            </datalist>

        </form>
    </div>
</div>

<script>

    const addBtn = document.querySelector("#add-user")
    const rmBtn = document.querySelector("#rm-user")

    function fromHTML(html, trim = true) {
        // Process the HTML string.
        html = trim ? html.trim() : html;
        if (!html) return null;

        // Then set up a new template element.
        const template = document.createElement('template');
        template.innerHTML = html;
        const result = template.content.children;

        // Then return either an HTMLElement or HTMLCollection,
        // based on whether the input HTML had one or more roots.
        if (result.length === 1) return result[0];
        return result;
    }

    
    function changeFIO(obj) {
        obj = $(obj)

        const particDiv = document.querySelector("#participants")
        const fioList = $("#exampleITMONameList")

        const studID = obj[0].value
        const studCh = obj.parents().eq(2)

        const fios = fioList.find(`#fio-${studID}`)
        if (fios.length > 0) {
            studCh.find("#stud-fio")[0].value = fioList.find(`#fio-${studID}`)[0].value
        } else {
            studCh.find("#stud-fio")[0].value = ""
        }
    }

    function changeOnEnter(obj) {
        if(event.key === 'Enter') {
            changeFIO(obj)
        }
    }

    {% comment %} <input onchange="changeFIO(this)" list="exampleITMOIDList" class="form-control" id="stud-id" name="stud-id-${studNumber}" required> {% endcomment %}

    function genStudentFieldStr(studNumber) {
        return `
            <div class="row border-bottom pb-4 mb-3" id="student-${studNumber}">
                <p class="fw-medium"> Участник ${studNumber} </p>
                <div class="col-md-4 my-md-0 mb-3">
                    <div class="form-floating">
                        <input onchange="changeFIO(this)" list="exampleITMOIDList" class="form-control" id="stud-id" name="stud-id-${studNumber}" required>
                        <label>ITMO ID участника</label>
                        <div class="invalid-feedback">
                            Поле не заполнено
                        </div>
                    </div>
                </div>
                <div class="col-md-8">
                    <div class="form-floating">
                        <input class="form-control" type="text" value="" id="stud-fio" disabled required>
                        <label>ФИО участника</label>
                        <div class="invalid-feedback">
                            Поле не заполнено
                        </div>
                    </div>
            </div>
        `
    }
    const particDiv = document.querySelector("#participants")

    for (let i = 1; i < 4; i++) {
        const divEl = fromHTML(genStudentFieldStr(i))
        particDiv.append(divEl)
    }

    addBtn.onclick = function() {
        const particDiv = document.querySelector("#participants")
        const fioList = $("#exampleITMONameList")

        const studNumber = particDiv.children.length
        const divEl = fromHTML(genStudentFieldStr(studNumber + 1))

        $("#stud-number")[0].value = studNumber + 1
        particDiv.append(divEl)
    };
    rmBtn.onclick = function() {
        const particDiv = document.querySelector("#participants")
        const fioList = $("#exampleITMONameList")

        const studNumber = particDiv.children.length
        const lastDiv = document.querySelector("#student-".concat(studNumber))

        $("#stud-number")[0].value = studNumber - 1
        lastDiv.remove()
    };
</script>

{% endblock content %}
